// 经典平差.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <malloc.h>
#include "classic.h"
#include "public.h"

//////////////////////////////////////////////////////////////////////////
//     参数平差例题（观测值独立）
void Adjust_Example() 
{
	char *file="./例题/参数平差/data.txt";
	FILE *fp=fopen(file,"r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开\n");
		return;
	}

	int n,t;
	fscanf(fp,"%d%d",&n,&t);

    	double *A=(double *)malloc(sizeof(double)*t*n);
    	double  *L=(double *)malloc(sizeof(double)*n);
	double  *P=(double *)malloc(sizeof(double)*n);
	double  *X=(double *)malloc(sizeof(double)*t);
	double  *N=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double  *V=(double *)malloc(sizeof(double)*n);
	
	for(int i=0;i<n;i++) 
	{
		for(int j=0;j<t;j++)// 读取误差方程系数
		{
			fscanf(fp,"%lf",A+i*t+j);
		}
		fscanf(fp,"%lf",L+i); // 读取误差方程自由项
	}

	for(int i=0;i<n;i++)  // 输入观测权
	{
		fscanf(fp,"%lf",P+i);
	}
	fclose(fp);
	
	fp=fopen("./例题/参数平差/result.txt","w");
	
	fprintf(fp,"=== 参数平差(观测值独立)计算 ===\n");
	fprintf(fp,"\n误差方程:\n");
	
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<t;j++)
			fprintf(fp,"%7.3lf ",A[i*t+j]);
		fprintf(fp,"%7.3lf \n",L[i]);
	}

	double m=Adjust( n, t, A, L,  P,  X, N, V);
	
	fprintf(fp,"参数平差值及其中误差：\n");
	for(int i=0;i<t;i++)
	{
		fprintf(fp,"%4d %10.4lf %10.4lf\n",i+1,X[i],sqrt(N[ij(i,i)])*m);
	}
	
	fprintf(fp,"\n最小二乘残差(V)：\n");
	for(int i=0;i<n;i++)fprintf(fp,"%5d%10.3lf\n",i+1,V[i]);
	fprintf(fp,"单位权中误差：μ=%.3lf",m);
		
	PrintM2(fp,N,t,t,"%9.6lf ","参数平差值的权逆阵",true);
	
	fclose(fp);
	free(A);
	free(L);
	free(P);
	free(X);
	free(N);
	free(V);
	
}

//////////////////////////////////////////////////////////////////////////
//        相关观测值参数平差（从独立观测值参数平差的例题改造而来）
void Co_Adjust_Example()
{
	FILE *fp=fopen("./例题/相关参数平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开\n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);
	
    	double *A=(double *)malloc(sizeof(double)*t*n);
    	double  *L=(double *)malloc(sizeof(double)*n);
	double  *P=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double  *X=(double *)malloc(sizeof(double)*t);
	double  *Qx=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double  *V=(double *)malloc(sizeof(double)*t);
	
	for(int i=0;i<n;i++) // 输入误差方程系数
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}
	
	for(int i=0;i<n*(n+1)/2;i++)  // 输入观测权矩阵
		fscanf(fp,"%lf",P+i);
	fclose(fp);
	
	fp=fopen("./例题/相关参数平差/result.txt","w");
	
	fprintf(fp,"=== 参数平差(观测值相关)计算 ===\n");

	fprintf(fp,"\n误差方程式:\n");
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<t;j++)
			fprintf(fp,"%7.3lf ",A[i*t+j]);
		fprintf(fp,"%7.3lf \n",L[i]);
	}
	
	PrintM2(fp,P,n,n,"%6.2lf ","权矩阵",false);
	
	double m=Co_Adjust(n,t,A,L,P,X,Qx,V);
	
	fprintf(fp,"\n参数平差值及其中误差：\n");
	for(int i=0; i<t; i++)
	{
		fprintf(fp,"%4d %10.3lf %10.3lf\n",i+1,X[i],sqrt(Qx[ij(i,i)])*m);
	}
	
	PrintM(fp,V,n,1,"%6.2lf ","最小二乘残差(V)",true);
	PrintM2(fp,Qx,t,t,"%10.5lf ","参数平差值的权逆阵",false);
	
	fprintf(fp,"单位权中误差：μ=%.3lf",m);
	
	fclose(fp);
	free(A);
	free(L);
	free(P);
	free(X);
	free(Qx);
	free(V);
}


//////////////////////////////////////////////////////////////////////////
//   条件平差例题（观测值独立）
void Condition_Example()
{	
	FILE *fp=fopen("./例题/条件平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开\n");
		return;
	}
	
	int n,r;
	fscanf(fp,"%d%d",&n,&r);
	
    	double  *B=(double *)malloc(sizeof(double)*n); //系数矩阵
    	double  *W=(double *)malloc(sizeof(double)*r);  //自由项向量
	double  *P=(double *)malloc(sizeof(double)*n);  //权数组
	double  *V=(double *)malloc(sizeof(double)*n);  //观测值改正数向量
	double  *Qx=(double *)malloc(sizeof(double)*n*(n+1)/2); //观测值平差值的权逆阵
	
	for(int i=0;i<r;i++) // 输入条件方程
	{
		for(int j=0;j<n;j++)
		{
			fscanf(fp,"%lf",B+i*n+j);
		}
		fscanf(fp,"%lf",W+i);
	}
	
	for(int i=0;i<n;i++)  // 输入观测权（不是权倒数）
	{
		fscanf(fp,"%lf",P+i);
	}
	fclose(fp);
	
	double m=Condition(n,r,B,W,P,Qx,V);
	fp=fopen("例题\\条件平差\\Result.txt","w");
	
	PrintEquation(fp,B,W,r,n,"%7.3lf","条件方程式");
	
	PrintM(fp,P,n,n,"%6.3lf ","观测值的权",false);
	
	PrintM(fp,V,n,1,"%10.3lf ","观测值的改正数(V)",true);

	fprintf(fp,"观测值平差值的中误差：\n");
	for(int i=0; i<n; i++)
	{
		fprintf(fp,"%4d %10.2lf\n",i+1,sqrt(Qx[ij(i,i)])*m);
	}

	double F[]={1.0, 0.0, 1.0, -1.0, 0.0, 0.0 };
	double qi=Calculate_q(Qx,F,n);
	fprintf(fp,"\n函数的中误差: %.2lf",sqrt(qi)*m);

	fprintf(fp,"\n单位权中误差：μ=%.3lf",m);
	
	PrintM2(fp,Qx,n,n," %8.3lf","观测值平差值的权逆阵",true);

	fclose(fp);
	free(B);
	free(W);
	free(P);
	free(V);
	free(Qx);
}


//////////////////////////////////////////////////////////////////////////
//    相关条件平差算例
void Co_Condition_Example()
{
	int n,r;
	
	FILE *fp=fopen("./例题/相关条件平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开\n");
		return;
	}
	
	fscanf(fp,"%d%d",&n,&r);
	
    	double *B=(double *)malloc(sizeof(double)*r*n);
    	double  *W=(double *)malloc(sizeof(double)*r);
	double  *Q=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double  *V=(double *)malloc(sizeof(double)*r);
	
	for(int i=0;i<r;i++) // 输入条件方程
	{
		for(int j=0;j<n;j++)
		{
			fscanf(fp,"%lf",B+i*n+j);
		}
		fscanf(fp,"%lf",W+i);
	}
	
	for(int i=0;i<n*(n+1)/2;i++)  // 输入观测权逆阵
	{
		fscanf(fp,"%lf",Q+i);
	}
	fclose(fp);

	fp=fopen("例题\\相关条件平差\\Result.txt","w");
	PrintEquation(fp,B,W,r,n," %6.2lf","条件方程");

	double m=Co_Condition(n,r,B,W,Q,V);
		
	PrintM(fp,V,n,1,"%6.3lf","观测值的改正数(V)",true);

	fprintf(fp,"单位权中误差：μ=%.3lf",m);

	double F[]={1.9, -0.27, 0.27, 0.11, 0.04, 0.01};
	double q=Calculate_q(Q,F,n); //第1章：权倒数计算函数 
	fprintf(fp,"\n函数的中误差：m=%.3lf",m*sqrt(q));
	
	fclose(fp);
}



//////////////////////////////////////////////////////////////////////////
//  具有条件的参数平差例题(观测值独立)
void Adjust_With_Constraint_Example()
{
	int n,t,r;
	
	FILE *fp=fopen("./例题/具有条件的参数平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开\n");
		return;
	}
	
	fscanf(fp,"%d%d%d",&n,&t,&r);
	
    	double *A=(double *)malloc(sizeof(double)*(r+n)*t); //误差方程系数阵
    	double  *L=(double *)malloc(sizeof(double)*(r+n));  //误差方程自由项
	double  *P=(double *)malloc(sizeof(double)*(r+n));  //观测权
	double  *V=(double *)malloc(sizeof(double)*(n));  //残差
	double  *QX=(double *)malloc(sizeof(double)*(t+1)*t/2); //未知参数的权逆阵
	double  *X=(double *)malloc(sizeof(double)*t);  //参数片长值
	
	for(int i=0;i<n+r;i++) // 输入误差方程和条件方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}
	
	for(int i=0;i<n;i++)  // 输入观测权
		fscanf(fp,"%lf",P+i);
	fclose(fp);
	
	fp=fopen("./例题/具有条件的参数平差/Result.txt","w");
	
	fprintf(fp,"具有条件的参数平差算例\n");
	PrintEquation(fp,A,L,n,t," %8.3lf","误差方程");
	PrintEquation(fp,A+n*t,L+n,r,t," %8.3lf","条件方程");
	PrintM(fp,P,n,n," %6.2lf","观测值的权",false);
	
	double m=Adjust_With_Constraint(n,t,r,false,A,L,A+n*t,L+n,P,X,QX,V);
	
	fprintf(fp,"\n单位权中误差：μ=%.3lf",m);
	fprintf(fp,"\n参数平差值及其中误差：\n");
	for(int i=0;i<t;i++)
	{
		fprintf(fp,"%4d %10.3lf %10.4lf\n",i+1,X[i],sqrt(QX[ij(i,i)])*m);
	}
	
	PrintM2(fp,QX,t,t,"%10.3lf ","参数平差值的权逆阵",true);
	PrintM(fp,V,n,1,"%10.3lf ","最小二乘残差(V)",true);

	fclose(fp);
	free(A);
	free(L);
	free(P);
	free(V);
	free(QX);
	free(X);
}


//////////////////////////////////////////////////////////////////////////
//    具有参数的条件平差算例
void Condition_With_X_Example()
{	
	FILE *fp=fopen("./例题/具有参数的条件平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开\n");
		return;
	}
	
	int n,t,r; //观测值个数、参数个数、条件方程个数
	fscanf(fp,"%d%d%d",&n,&t,&r);
	
    	double *B=(double *)malloc(sizeof(double)*r*n); //条件方程系数阵(V)
    	double *A=(double *)malloc(sizeof(double)*r*t); //条件方程系数阵(X)
    	double  *W=(double *)malloc(sizeof(double)*r);  //条件方程自由项
	double  *P=(double *)malloc(sizeof(double)*(n+1)*n/2);  //观测权矩阵
	double  *V=(double *)malloc(sizeof(double)*n);  //残差
	double  *X=(double *)malloc(sizeof(double)*t);  //参数平差值
	double  *QX=(double *)malloc(sizeof(double)*(t+1)*t/2); //参数平差值的权逆阵
	
	for(int i=0;i<r;i++) // 输入条件方程系数
	{
		for(int j=0;j<n;j++)
		{
			fscanf(fp,"%lf",B+i*n+j);
		}
		for(int j=0;j<t;j++)
		{
			fscanf(fp,"%lf",A+i*t+j);
		}
		fscanf(fp,"%lf",W+i); 
	}
	
	for(int i=0;i<n*(n+1)/2;i++)  // 输入观测权矩阵
	{
		fscanf(fp,"%lf",P+i);
	}
	fclose(fp);

	fp=fopen("./例题/具有参数的条件平差/Result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	fprintf(fp,"  ==== 具有参数的条件平差 ====\n");
	
	fprintf(fp,"\n条件方程：");
	for(int i=0;i<r;i++) // 输出条件方程
	{
		fprintf(fp,"\n");
		for(int j=0;j<n;j++)
		{
			fprintf(fp,"%6.2lf ",B[i*n+j]);
		}		
		for(int j=0;j<t;j++)
		{
			fprintf(fp,"%6.2lf ",A[i*t+j]);
		}
		fprintf(fp,"%6.3lf ",W[i]);
	}
	double m=Condition_With_X(n,r,t,true,B,A,W,P,X,QX,V);
	
	fprintf(fp,"\n单位权中误差：μ=%.3lf",m);
	PrintM(fp,X,t,t,"%8.3lf ","参数平差值X",false);
	PrintM2(fp,QX,t,t,"%9.5lf","参数平差值的权逆阵QX",false);
	PrintM(fp,V,n,1,"%8.3lf ","观测值改正数(V)",true);

	fclose(fp);	
	free(B);
	free(A);
	free(W);
	free(V);
	free(P);
	free(X);
	free(QX);
}


///////////////////////////////////////////////////////////////////////////////////////





int main(int argc, char* argv[])
{
	printf("\n    ===== 第3章 经典平差 =====\n");
	printf("\n	1. 参数平差");
	printf("\n	2. 参数平差(相关)");
	printf("\n	3. 条件平差(独立)");
	printf("\n	4. 条件平差(相关)");
	printf("\n	5. 具有条件的参数平差");
	printf("\n	6. 具有参数的条件平差\n");
	
	int sw;
	scanf("%d",&sw);

	switch(sw) {
	case 1:
		printf("\n\n参数平差\n");
		Adjust_Example();// 最小二乘平差
		break;
	case 2:
		printf("\n相关观测值参数平差");
		Co_Adjust_Example(); // 相关观测值参数平差
		break;
	case 3:
		printf("\n条件平差例题（观测值独立）\n");
		Condition_Example();  // 条件平差例题（观测值独立）
		break;
	case 4:
		printf("\n条件平差例题（观测值相关）\n");
		Co_Condition_Example();//   相关条件平差算例
		break;
	case 5:
		printf("\n具有条件的参数平差例题(观测值独立)\n");
		Adjust_With_Constraint_Example(); //   具有条件的参数平差例题(观测值独立)
		break;
	case 6:
		printf("\n具有参数的条件平差算例\n");
		Condition_With_X_Example(); //   具有参数的条件平差算例
		break;
	default:
		printf("\n什么也没有做！\n");
		
	}

	
	return 0;

}
