#include "levelingad.h"
#include "public.h"

//////////////////////////////////////////////////////////////////////////
//最小二乘平差算例
void main1()
{
	char *datafile ="./算例/最小二乘平差/data.txt";
	char *resultfile ="./算例/最小二乘平差/result.txt";
	
	printf("\n\n最小二乘平差计算\n");
	printf("数据文件： %s\n",datafile);
	printf("结果文件： %s\n",resultfile);
	
	FILE *fp=fopen(resultfile,"w");
	if (fp==NULL)
	{
		fprintf(stderr,"创建结果文件失败！\n");
		return;
	}
	
	struct CLevelingAdjust level;
	CLevelingAdjust_CLevelingAdjust(&level);
	
	level.resultfp=fp;
	
	
	level.Inputdata(datafile,&level); 
	
	level.Printdata(&level);
	level.LS_Adjustment(&level);

	fclose(fp);
	level.de_CLevelingAdjust(&level);
}

//////////////////////////////////////////////////////////////////////////
//闭合差计算算例
void main5()
{
	char *datafile ="./算例/闭合差计算/data.txt";
	char *resultfile ="./算例/闭合差计算/result.txt";
	
	printf("\n\n闭合差计算\n");
	printf("数据文件： %s\n",datafile);
	printf("结果文件： %s\n",resultfile);
	
	FILE *fp=fopen(resultfile,"w");
	if (fp==NULL)
	{
		fprintf(stderr,"创建结果文件失败！\n");
		return;
	}
	
	struct CLevelingAdjust level;
	CLevelingAdjust_CLevelingAdjust(&level);
	level.resultfp=fp;
	level.Inputdata(datafile,&level); 
	//level.printdata();
	
	level.LineClosure(&level);
	level.LoopClosure(&level);
	
	fclose(fp);
	level.de_CLevelingAdjust(&level);
	
}

//////////////////////////////////////////////////////////////////////////
// 秩亏自由网平差算例
void main3()
{
	char *datafile ="./算例/自由网平差/data.txt";
	char *resultfile ="./算例/自由网平差/result.txt";
	
	printf("\n\n自由网平差计算\n");
	printf("数据文件： %s\n",datafile);
	printf("结果文件： %s\n",resultfile);
	
	FILE *fp=fopen(resultfile,"w");
	if (fp==NULL)
	{
		fprintf(stderr,"创建结果文件失败！\n");
		return;
	}
	
	struct CLevelingAdjust level;
	CLevelingAdjust_CLevelingAdjust(&level);
	level.resultfp=fp;
	level.Inputdata(datafile,&level); 
	//level.printdata();
	level.FreeNetAdjust(&level);
	
	fclose(fp);
	level.de_CLevelingAdjust(&level);
}


//////////////////////////////////////////////////////////////////////////
//  拟稳平差算例
void main4()
{
	char *datafile ="./算例/拟稳平差/data.txt";
	char *resultfile ="./算例/拟稳平差/result.txt";
	char *QuasiStablefile ="./算例/拟稳平差/拟稳点.txt";
	
	printf("\n\n拟稳平差计算\n");
	printf("数据文件： %s\n",datafile);
	printf("结果文件： %s\n",resultfile);
	
	FILE *fp=fopen(resultfile,"w");
	if (fp==NULL)
	{
		fprintf(stderr,"创建结果文件失败！\n");
		return;
	}
	
	struct CLevelingAdjust level;
	CLevelingAdjust_CLevelingAdjust(&level);
	level.resultfp=fp;
	level.Inputdata(datafile,&level); 
	//level.printdata();
	level.Quasi_Stable(QuasiStablefile,&level);

	fclose(fp);
	level.de_CLevelingAdjust(&level);
}




//////////////////////////////////////////////////////////////////////////
//粗差探测差算例
void main2()
{
	char *datafile ="./算例/粗差探测/data.txt";
	char *resultfile ="./算例/粗差探测/result.txt";
	
	printf("\n\n粗差探测计算\n");
	printf("数据文件： %s\n",datafile);
	printf("结果文件： %s\n",resultfile);
	
	FILE *fp=fopen(resultfile,"w");
	if (fp==NULL)fprintf(stderr,"创建结果文件失败！\n");
	
	struct CLevelingAdjust level;
	CLevelingAdjust_CLevelingAdjust(&level);
	level.resultfp=fp;

	level.Inputdata(datafile,&level); 
	//level.printdata();
	
	level.DataSnooping(0.003,&level);
	
	fprintf(fp,"\n\n在第1、第6号观测值加入模拟粗差之后进行粗差探测:\n");
	level.L[0]+=0.15;
	level.L[5]-=0.05;
	
	level.DataSnooping(0.003,&level);
	
	fclose(fp);	
	level.de_CLevelingAdjust(&level);
}





void main()
{
	printf("     ===== 第5章 水准网平差 =====");
	printf("\n	1.最小二乘平差");
	printf("\n	2.粗差探测");
	printf("\n	3.自由网平差");
	printf("\n	4.拟稳平差");
	printf("\n	5.闭合差计算\n");
	
	int sw;
	scanf("%d",&sw);

	switch(sw) {
	case 1:
		main1();
		break;
	case 2:
		main2();
		break;
	case 3:
		main3();
		break;
	case 4:
		main4();
		break;
	case 5:
		main5();
		break;
	default:
		break;
	}

	return;


}


