// LevelingAdjust.h: interface for the CLevelingAdjust class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _LEVELINGAD_H
#define _LEVELINGAD_H

#include "stdio.h"

/*class CLevelingAdjust  
{
public:
	CLevelingAdjust();
	virtual ~CLevelingAdjust();

	int m_Lnumber;      //高差总数
	int m_Pnumber;      //总点数
	int m_knPnumber;    //已知点数
	int m_StablePnumber; //拟稳点数
	double m_pvv;        //[pvv]
	FILE   *resultfp;    //文件指针,输出计算结果

	double  m_Sigma;  //验前单位权中误差（粗差探测、 闭合差计算用）
	double  Alhpa;     // 显著水平（粗差探测程序用）
	
	int *StartP;     //高差起点号
	int *EndP;       //高差终点号
	char   **Pname;   //点名地址数组
	double  *L;       //观测值数组
	double  *Height;  //高程值数组
	double  *P;       //观测值的权

	double  *ATPA,*ATPL; //法方程系数矩阵与自由项
	double  *dX;      //参数平差值（高程改正数）   
	double  *V;       //残差数组
	double  m_mu;      //验后单位权中误差
	
	int *IsStable; //是否为拟稳点号
		
	void   Inputdata(char *datafile);//输入原始数据函数
	void   Printdata(); //输出原始数据函数
	int    GetStationNumber(char *name); //获取点号函数
	void   ca_H0();       //近似高程计算函数
	void   ca_ATPA();  //法方程组成函数
	void   ca_dX();    //平差值计算函数
	void   PrintResult();  //精度估计与平差值输出函数
	double ca_V();     //残差计算函数	

    	void   LS_Adjustment();//最小二乘平差函数
	void   Quasi_Stable( char *file);//拟稳平差函数
    	void   FreeNetAdjust();//自由网平差函数
		
	void  FindShortPath(int p1,int exclude, int root[],
						  double diff[],double S[]);    //最短路线搜索
	void  LineClosure(); // 路线闭合差计算
	void  LoopClosure(); //环闭合差计算
	

	void DataSnooping(double arfa);//粗差探测
		
};
*/

struct CLevelingAdjust{
	int m_Lnumber;      //高差总数
	int m_Pnumber;      //总点数
	int m_knPnumber;    //已知点数
	int m_StablePnumber; //拟稳点数
	double m_pvv;        //[pvv]
	FILE   *resultfp;    //文件指针,输出计算结果

	double  m_Sigma;  //验前单位权中误差（粗差探测、 闭合差计算用）
	double  Alhpa;     // 显著水平（粗差探测程序用）
	
	int *StartP;     //高差起点号
	int *EndP;       //高差终点号
	char   **Pname;   //点名地址数组
	double  *L;       //观测值数组
	double  *Height;  //高程值数组
	double  *P;       //观测值的权

	double  *ATPA,*ATPL; //法方程系数矩阵与自由项
	double  *dX;      //参数平差值（高程改正数）   
	double  *V;       //残差数组
	double  m_mu;      //验后单位权中误差
	
	int *IsStable; //是否为拟稳点号
	
	
	void (*CLevelingAdjust)(struct CLevelingAdjust *cla);//构造函数
	void (*de_CLevelingAdjust)(struct CLevelingAdjust *cla);//析构函数
	
	
	void   (*Inputdata)(char *datafile,struct CLevelingAdjust *cla);//输入原始数据函数
	void   (*Printdata)(struct CLevelingAdjust *cla); //输出原始数据函数
	int    (*GetStationNumber)(char *name,struct CLevelingAdjust *cla); //获取点号函数
	void   (*ca_H0)(struct CLevelingAdjust *cla);       //近似高程计算函数
	void   (*ca_ATPA)(struct CLevelingAdjust *cla);  //法方程组成函数
	void   (*ca_dX)(struct CLevelingAdjust *cla);    //平差值计算函数
	void   (*PrintResult)(struct CLevelingAdjust *cla);  //精度估计与平差值输出函数
	double (*ca_V)(struct CLevelingAdjust *cla);     //残差计算函数	

    	void   (*LS_Adjustment)(struct CLevelingAdjust *cla);//最小二乘平差函数
	void   (*Quasi_Stable)( char *file,struct CLevelingAdjust *cla);//拟稳平差函数
    	void   (*FreeNetAdjust)(struct CLevelingAdjust *cla);//自由网平差函数
		
	void  (*FindShortPath)(int p1,int exclude, int root[],
						  double diff[],double S[],struct CLevelingAdjust *cla);    //最短路线搜索
	void  (*LineClosure)(struct CLevelingAdjust *cla); // 路线闭合差计算
	void  (*LoopClosure)(struct CLevelingAdjust *cla); //环闭合差计算
	

	void (*DataSnooping)(double arfa,struct CLevelingAdjust *cla);//粗差探测
};

//构造函数
void CLevelingAdjust_CLevelingAdjust(struct CLevelingAdjust *cla);
//析构函数
void CLevelingAdjust_de_CLevelingAdjust(struct CLevelingAdjust *cla);



//////////////////////////////////////////////////////////////////////////
//   原始数据输入函数
void CLevelingAdjust_Inputdata(char *datafile,struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//   原始数据写到结果文件
void CLevelingAdjust_Printdata(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//	 点名存贮，返回点名对应的点号
int  CLevelingAdjust_GetStationNumber(char *name,struct CLevelingAdjust *cla);
                           




                                           
//////////////////////////////////////////////////////////////////////////
//	      高程近似值计算
void CLevelingAdjust_ca_H0(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//  组成法方程
void CLevelingAdjust_ca_ATPA(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//    高程平差值计算
void CLevelingAdjust_ca_dX(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//   残差计算
double  CLevelingAdjust_ca_V(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//   平差值输出
void  CLevelingdjust_PrintResult(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//    水准网最小二乘平差
void  CLevelingAdjust_LS_Adjustment(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//       水准网－自由网平差
void CLevelingAdjust_FreeNetAdjust(struct CLevelingAdjust *cla);



//////////////////////////////////////////////////////////////////////////
//       水准网拟稳平差
//       2008－07－16
void CLevelingAdjust_Quasi_Stable(char *file,struct CLevelingAdjust *cla); //file是拟稳点名文件

	
//////////////////////////////////////////////////////////////////////////
//	路线闭合差计算	
void CLevelingAdjust_LineClosure(struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//  搜索最短路径
void CLevelingAdjust_FindShortPath(int p,int exclude,int neighbor[],
				double diff[],double S[],struct CLevelingAdjust *cla);


//////////////////////////////////////////////////////////////////////////
//	环闭合差计算	
void CLevelingAdjust_LoopClosure(struct CLevelingAdjust *cla);


#include "probability.h"
//////////////////////////////////////////////////////////////////////////
//   水准网粗差探测
void CLevelingAdjust_DataSnooping(double arfa,struct CLevelingAdjust *cla);



#endif // _LEVELINGAD_H
