// 近代平差.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include "classic.h"
#include "modern.h"
#include "collocation.h"
#include <malloc.h>
#include <stdbool.h>
#include "public.h"


//////////////////////////////////////////////////////////////////////////
//   Kalnman滤波算例1:武测－广义测量平差（新版）-P122,
void KalmanFilter_Example1()
{
	const int t=1;
	const int n=1;
	const int K=2; //历元数
	
	double *A=(double *)malloc(sizeof(double)*n*t);
	double *F=(double *)malloc(sizeof(double)*t*t);
	double *P=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double *L=(double *)malloc(sizeof(double)*n);
	A[0]=1.0;
	F[0]=0.5;
	P[0]=0.5;
	

	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);

	X[0]=0.0;
	QX[0]=1.0;

	double *QW=(double *)malloc(sizeof(double)*t*(t+1)/2);
	QW[0]=1.0;

	
	FILE *fp=fopen("./算例/Kalman滤波1/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	
	L[0]=4.0;
	for( int k=1; k<=K; k++)
	{

		bool rn=KalmanFilter(n, t,A, L, P,F, QW, X, QX);/////////////////////////////////////////////
		if(!rn)
		{
			fprintf(stderr,"调用KalmanFilter函数失败!");
			return;
		}
		fprintf(fp,"\n第%d次滤波\n状态估值:\n",k);
		for(int i=0;i<t;i++)
		{
			fprintf(fp,"  %8.2lf\n",X[i]);		
			
		}

		fprintf(fp,"\n状态向量的方差矩阵\n");		
		for(int i=0; i<t; i++)
		{
			for(int j=0;j<=i;j++)
			{
				fprintf(fp,"  %8.2lf",QX[ij(i,j)]);/////////////////////////////////////////////		
			}
			fprintf(fp,"\n");		
		}

		L[0]=2.0;
	}
		
	fclose(fp);
	free(A);
	free(F);
	free(P);
	free(L);
	free(X);
	free(QX);
	free(QW);
		
}


//////////////////////////////////////////////////////////////////////////
//   Kalnman滤波算例2:武测－广义测量平差（新版）-P123,
void KalmanFilter_Example2()
{
	const int t=1;
	const int n=1;
	const int K=4; //历元数
	
	double *A=(double *)malloc(sizeof(double)*n*t);
	double *F=(double *)malloc(sizeof(double)*t*t);
	double *P=(double *)malloc(sizeof(double)*n*(n+1)/2);
	A[0]=1.0;
	F[0]=1.0;
	P[0]=1.0/15.0;
	
	double L[]={0.0,10.0,20.0,30.0,40.0};
	
	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	
	X[0]=0.0;
	QX[0]=100.0;
	
	double *QW=(double *)malloc(sizeof(double)*t*(t+1)/2);
	QW[0]=25.0;
	
	
	FILE *fp=fopen("./算例/Kalman滤波2/result2.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		free(A);
		free(F);
		free(P);
		free(X);
		free(QX);
		free(QW);
		return;
	}
	
	fprintf(fp,"\n  k    状态估值   状态估值的方差\n");
	
	for( int k=1; k<=K; k++)
	{
		
		bool rn=KalmanFilter(n, t,A, L+k, P,F, QW, X, QX);
		if(!rn)
		{
			fprintf(stderr,"调用KalmanFilter失败!\n");
			fclose(fp);
			free(A);
			free(F);
			free(P);
			free(X);
			free(QX);
			free(QW);
			return;
		}
		fprintf(fp,"\n  %d",k);
		for(int i=0;i<t;i++)
		{
			fprintf(fp,"  %8.2lf    %8.2lf",X[i],QX[0]);		
		}
	}
	
	fclose(fp);
	free(A);
	free(F);
	free(P);
	free(X);
	free(QX);
	free(QW);
	
}

//////////////////////////////////////////////////////////////////////////
//   Kalnman滤波算例, 教材采用本算例
//   2008－8－2，自编算例，状态方程是一个常加速模型
void KalmanFilter_Example3()
{
	const int t=2;  //状态向量的维数
	const int n=1;  //每历元的观测值个数
	const int K=10; //历元数
	
	double Ak[2]={1.0,0.0} ; //误差方程系数矩阵 n*t
	double F[4]={ 1.0, 1.0, 0.0 ,1.0 }; //状态转移矩阵  t*t
	double P[1]={ 1.0 }; //观测值权矩阵 n*(n+1)/2
	double L[]={0.0,10.1,20.0,29.8,40.3,50.5,59.9,70.0,80.3,90.0,99.5};
	
	double X[2]={ 0.0, 6.0}; //状态的初值 t
	double QX[3]={ 0.0001, 0.0, 0.0002}; //状态初始值的方差 t*(t+1)/2
	
	double QW[3]={0.01/3.0, 0.01/2.0, 0.01}; //状态噪声方差矩阵 t*(t+1)/2

	
	FILE *fp=fopen("./算例/KALMAN滤波/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	
	fprintf(fp,"\n  k    状态估值及状态估值的方差\n");
	
	for( int k=1; k<=K; k++)
	{
		bool rn=KalmanFilter(n, t,Ak, L+k, P,F, QW, X, QX);
		if(!rn)
		{
			fprintf(stderr,"调用KalmanFilter失败!\n");
			fclose(fp);
			return;
		}
		fprintf(fp,"\n  %2d",k);
		for(int i=0;i<t;i++)
		{
			fprintf(fp,"  %8.2lf±%.2lf",X[i],QX[ij(i,i)]);		
		}
	}
	fclose(fp);
}


//////////////////////////////////////////////////////////////////////////
//   Kalnman滤波算例3
//   本例取自武测－广义测量平差（新版）-P123的例题，然后将F改为1.5
void KalmanFilter_Example()
{
	const int t=1;
	const int n=1;
	const int K=4; //历元数
	
	double A[1],F[1],P[1];//double A[n*t],F[t*t],P[n*(n+1)/2]
	A[0]=1.0;
	F[0]=1.0;
	P[0]=1.0/15.0;
	
	double L[]={0.0,10.0,20.0,30.0,40.0};
	
	double X[1], QX[1];//double X[t], QX[t*(t+1)/2];
	
	X[0]=0.0;
	QX[0]=100.0;
	
	double QW[1];//double QW[t*(t+1)/2]
	QW[0]=25.0;
	
	
	FILE *fp=fopen("./算例/KALMAN滤波/result.txt","w");

	fprintf(fp,"\n本例取自武测－广义测量平差（新版）-P123的例题\n");
	
	
	fprintf(fp,"\n  k    状态估值   状态估值的方差\n");
	
	for( int k=1; k<=K; k++)
	{
		
		bool rn=KalmanFilter(n, t,A, L+k, P,F, QW, X, QX);
		if(!rn)
		{
			fprintf(stderr,"调用KalmanFilter失败!\n");
			return;
		}
		
		fprintf(fp,"\n  %d",k);
		for(int i=0;i<t;i++)
		{
			fprintf(fp,"  %8.2lf    %8.2lf",X[i],QX[0]);		
		}
	}
	
	fclose(fp);
	
}

//////////////////////////////////////////////////////////////////////////
//     抗差估计例题（观测值不相关）
void Robust_Example()
{
	double  sigma=1.4, eps=0.002;

	FILE *fp=fopen("./算例/抗差估计/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr," 数据文件打不开! \n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);
	

	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	double *W=(double *)malloc(sizeof(double)*n);
	double *P=(double *)malloc(sizeof(double)*n);
	double *X=(double *)malloc(sizeof(double)*t);
	double *N=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	
	for(int i=0;i<n;i++) // 输入误差方程系数
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}
	for(int i=0;i<n;i++) // 输入观测权
	{
		fscanf(fp,"%lf",P+i);
	}
	fclose(fp);

	fp=fopen("./算例/抗差估计/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		free(A);
		free(L);
		free(W);
		free(P);
		free(X);
		free(N);
		free(V);
		return;
	}
	
	//PrintEquation(fp,A,L,n,t,"%8.3lf ","误差方程");
	
	double m=Adjust( n, t,A, L, P, X, N, V);

	fprintf(fp,"\n 未加粗差时最小二乘平差");
	fprintf(fp,"\n   单位权中误差：μ=%.3lf",m);
	PrintM(fp,X,t,t,"%10.3lf ","X",false);//////////////////////////////////////////////////////////////////////////////
	PrintM(fp,V,n,5,"%10.3lf ","V",false);
	
	
	L[8]+=10; L[1]+=5; //加入模拟粗差
	m=Adjust( n, t, A, L, P,  X, N, V);
	fprintf(fp,"\n\n加粗差后最小二乘平差\n   单位权中误差：μ=%.3lf",m);
	PrintM(fp,X,t,t,"%10.3lf ","X",false);
	PrintM(fp,V,n,5,"%10.3lf ","V",false);
	
	m=Robust(n,t,A,L,P,IGG1,1.5,2.5, sigma, eps,X,N,V,W);
	fprintf(fp,"\n\n加粗差后抗差估计\n   单位权中误差：μ=%.3lf",m);
	PrintM(fp,X,t,t,"%10.3lf ","X",false);
	PrintM(fp,V,n,5,"%10.3lf ","V",false);

	PrintM(fp,W,n,5,"%10.3lf ","W",false);
	
	fclose(fp);
	free(A);
	free(L);
	free(W);
	free(P);
	free(X);
	free(N);
	free(V);
}

//////////////////////////////////////////////////////////////////////////
//    相关抗差估计算例
void CoRobust_Example()
{
	FILE *fp=fopen("./算例/相关抗差估计/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr," 数据文件打不开！\n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);//输入观测值个数和参数个数
	

	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	double *W=(double *)malloc(sizeof(double)*n);
	double *P=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	
	for(int i=0;i<n;i++) // 输入误差方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}

	for(int i=0;i<n;i++) // 输入观测权矩阵
	{
		int tmp;
		fscanf(fp,"%d",&tmp);
		for(int j=0;j<=i;j++)
		{
			fscanf(fp,"%lf",P+i*(i+1)/2+j);
		}
	}
	fclose(fp);
	
	fp=fopen("./算例/相关抗差估计/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		free(A);
		free(L);
		free(W);
		free(P);
		free(X);
		free(QX);
		free(V);
		return;
	}
	

	PrintEquation(fp,A,L,n,t,"%8.3lf ","误差方程");///////////////////////////////////////////////////////////////////////////
	
	PrintM2(fp,P,n,4,"%15.7e ","权矩阵",true);//////////////////////////////////////////////////////////////////////////////////


	// 未加粗差的最小二乘平差
	double m=Co_Adjust( n, t,A, L,  P, X, QX, V);
	fprintf(fp,"\n    === 未加粗差时最小二乘平差 ===");
	fprintf(fp,"\n单位权中误差：μ=%.3lf",m);
	PrintM(fp,X,t,5,"%10.3lf","X",false);
	PrintM(fp,V,n,5,"%10.3lf","V",false);
	
	//  加入模拟粗差
	L[2]-=3.0;  L[3]+=5.0;	L[9]+=6.0;

	//最小二乘平差
	m=Co_Adjust( n, t,A, L,  P, X, QX, V);
	fprintf(fp,"\n\n    === 加粗差时最小二乘平差 ===");
	fprintf(fp,"\n单位权中误差：μ=%.3lf",m);
	PrintM(fp,X,t,5,"%10.3lf","X",false);
	PrintM(fp,V,n,5,"%10.3lf","V",false);	

	//  抗差估计
	double sigma=0.6, eps=0.01;
	m=CoRobust(n, t,A,L,P,IGG3,1.5,2.5, sigma, eps,X,QX, V,W);
	fprintf(fp,"\n\n    === 加粗差时抗差最小二乘平差 ===");
	fprintf(fp,"\n单位权中误差：μ=%.3lf",m);
	
	PrintM(fp,X,t,5,"%10.3lf","X",false);
	PrintM(fp,V,n,5,"%10.3lf","V",false);
	PrintM(fp,W,n,5,"%10.3lf","W(权因子)",false);
	
	fclose(fp);
	free(A);
	free(L);
	free(W);
	free(P);
	free(X);
	free(QX);
	free(V);
}

//////////////////////////////////////////////////////////////////////////
//     粗差探测例题
void DataSnooping_Example()
{
	FILE *fp=fopen("./算例/抗差估计/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr," 数据文件打不开! \n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);
	
    	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	bool *W=(bool *)malloc(sizeof(bool)*n);
	double *P=(double *)malloc(sizeof(double)*n);
	double *X=(double *)malloc(sizeof(double)*t);
	double *N=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	
	for(int i=0;i<n;i++) // 输入误差方程系数
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}
	for(int i=0;i<n;i++) // 输入观测权
	{
		fscanf(fp,"%lf",P+i);
	}
	fclose(fp);
	
	double  sigma=1.4, eps=3;
	
	fp=fopen("./算例/粗差探测/result.txt","w");
	double m=Adjust( n, t,A, L, P, X, N,V);

	fprintf(fp,"\n    ==== 未加粗差时最小二乘平差====");
	fprintf(fp,"\n单位权中误差: μ=%.3lf",m);
	PrintM(fp,X,t,t," %8.3lf","X",false);
	PrintM(fp,V,n,5," %8.3lf","V",false);
	
	L[8]+=10; L[1]+=5; //加入模拟粗差
	m=Adjust( n, t,A, L, P,  X, N, V);
	fprintf(fp,"\n\n    ==== 加粗差后最小二乘平差 ====");
	fprintf(fp,"\n单位权中误差: μ=%.3lf",m);
	PrintM(fp,X,t,t," %8.3lf","X",0);
	PrintM(fp,V,n,5," %8.3lf","V",0);
	
	m=DataSnooping(n,t,A,L,P,eps,sigma,X,N,V,W);
	fprintf(fp,"\n\n    ==== 加粗差后粗差探测 ====");
	fprintf(fp,"\n单位权中误差: μ=%.3lf",m);

	PrintM(fp,X,t,t," %8.3lf","X",false);
	PrintM(fp,V,n,5," %8.3lf","V",false);
	
	for(int i=0;i<n;i++)
	{
		if(!W[i]) fprintf(fp,"\n   第%d个观测值有粗差，被剔除",i+1);
	}
	
	fclose(fp);
	free(A);
	free(L);
	free(W);
	free(P);
	free(X);
	free(N);
	free(V);
}

//////////////////////////////////////////////////////////////////////////
//    序贯平差例题
void SuccessivExample2()
{
		char *file="./算例/参数平差/data.txt";
		
		FILE *fp=fopen(file,"r");
		if(fp==NULL)
		{
			fprintf(stderr,"数据文件打不开！\n");
			return;
		}
		
		int n,t;
		fscanf(fp,"%d%d",&n,&t);
		
		double *A=(double *)malloc(sizeof(double)*n*t);
		double *L=(double *)malloc(sizeof(double)*n);
		double *P=(double *)malloc(sizeof(double)*n);
		double *X=(double *)malloc(sizeof(double)*t);
		double *N=(double *)malloc(sizeof(double)*t*(t+1)/2);
		double *V=(double *)malloc(sizeof(double)*n);
		
		for(int i=0;i<n;i++) // 输入误差方程系数
		{
			for(int j=0;j<t;j++)
				fscanf(fp,"%lf",A+i*t+j);
			fscanf(fp,"%lf",L+i);
		}
		
		
		for(int i=0;i<n;i++)  // 输入观测权
			fscanf(fp,"%lf",P+i);
		fclose(fp);
		
		fp=fopen("./算例/序贯平差/result.txt","w");
		
		
		for(int i=0;i<t*(t+1)/2;i++)N[i]=0.0;
		
		for(int i=0;i<t;i++)
		{
			X[i]=0.0;
			N[ij(i,i)]=1.0e8;
		}
		
		
		for(int i=0;i<n;i++)
		{
			double m=Successive_Adjustment(1,t,A+i*t,L+i,P+i,X,N,V);
		}
		
		PrintM(fp,X,t,1,"%8.3lf ","X",true);
		PrintM2(fp,N,t,t,"%18.13lf ","QX",true);
		
		fclose(fp);
		free(A);
		free(L);
		free(P);
		free(X);
		free(N);
		free(V);
		
		return ;

}	



//////////////////////////////////////////////////////////////////////////
//    序贯平差例题
void SuccessivExample()
{
	FILE *fp=fopen("./算例/序贯平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开！\n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);
	
	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	double *P=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	
	for(int i=0;i<n;i++) // 输入误差方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}

	for(int i=0;i<n*(n+1)/2;i++) // 输入观测权矩阵
	{
		fscanf(fp,"%lf",P+i);
	}
	
	for(int i=0;i<t;i++) //输入参数的先验值
	{
		fscanf(fp,"%lf",&X[i]);
	}
	for(int i=0;i<t*(t+1)/2;i++) //输入参数的先验权阵
	{
		fscanf(fp,"%lf",&QX[i]);
	}	
	fclose(fp);

	fp=fopen("./算例/序贯平差/result.txt","w");

	fprintf(fp,"序贯平差例题计算结果\n");
	
/*	PrintM2(fp,P,n,n,"%3.2lf  ","P");*/
	double m=Successive_Adjustment(n,t,A,L,P,X,QX,V);
	
	PrintM(fp,X,t,1,"%8.3lf ","X",true); //输出参数平差值
	PrintM(fp,V,n,5,"%8.3lf  ","V",false);  //输出残差
	PrintM2(fp,QX,t,t," %8.4lf","QX",true); //输出参数平差值之权逆阵

	fprintf(fp,"\n单位权中误差:   μ=%.3lf\n",m);
	fclose(fp);
	free(A);
	free(L);
	free(P);
	free(X);
	free(QX);
	free(V);
	return ;
}




//////////////////////////////////////////////////////////////////////////
//  参数加权平差算例函数  
void Adjust_With_PX_Example()
{

	FILE *fp=fopen("./算例/参数加权平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开!\n");
		return;
	}
		
	int n,t,t1;
	fscanf(fp,"%d%d%d",&n,&t,&t1);

	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	double *P=(double *)malloc(sizeof(double)*n);
	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	double *X1=(double *)malloc(sizeof(double)*t1);
	double *PX1=(double *)malloc(sizeof(double)*t1*(t1+1)/2);
	int *Num=(int *)malloc(sizeof(int)*t1);
	
	for(int i=0;i<n;i++) //输入误差方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",&A[i*t+j]);
		fscanf(fp,"%lf",&L[i]);
	}
	

	for(int i=0;i<n;i++)
	{
		fscanf(fp,"%lf",P+i);
	}

	for(int i=0;i<t1;i++) //输入参数的先验值
	{
		fscanf(fp,"%d%lf",Num+i,X1+i);
		Num[i]=Num[i]-1;
	}

	//输入参数的先验权矩阵(下三角矩阵)
	for(int i=0;i<t1*(t1+1)/2;i++)
		fscanf(fp,"%lf",PX1+i);
	
	fclose(fp);
	
	fp=fopen("./算例/参数加权平差/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	
	fprintf(fp,"\n   参数加权平差算例：\n");

	PrintEquation(fp,A,L,n,t,"%8.3lf ","");

	double m=Adjust_With_PX(n,t,t1,false,A,L,P,X1,PX1,Num,X,QX,V);
	
	PrintM(fp,X,t,1,"%8.3lf","X",true);
	PrintM(fp,V,n,1,"%8.3lf","V",true);

	fprintf(fp,"\n单位权中误差：  μ=%lf\n",m);
	
	fprintf(fp,"\n   QX:");
	PrintM2(fp,QX,t,t," %8.4lf","",true);

	fclose(fp);
	free(A);
	free(L);
	free(P);
	free(X);
	free(QX);
	free(V);
	free(X1);
	free(PX1);
	free(Num);
		
}






//////////////////////////////////////////////////////////////////////////
//  参数加权平差和序贯平差的比较  
void Example_080625()
{
	
	FILE *fp1=fopen("./算例/参数加权平差+序贯平差/Data.txt","r");
	if(fp1==NULL)
	{
		fprintf(stderr," 数据文件打不开! \n");
		return;
	}
	
	int n,t,t1;
	fscanf(fp1,"%d%d%d",&n,&t,&t1);
	
	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	double *P=(double *)malloc(sizeof(double)*n*n);
	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	double *X1=(double *)malloc(sizeof(double)*t1);
	double *PX1=(double *)malloc(sizeof(double)*t1*(t1+1)/2);
	int *Num=(int *)malloc(sizeof(int)*t1);
	
	
	for(int i=0;i<n;i++) //输入误差方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp1,"%lf",&A[i*t+j]);
		fscanf(fp1,"%lf",&L[i]);
	}
	
	
	for(int i=0;i<n;i++)
	{
		fscanf(fp1,"%lf",P+i);
	}
	
	for(int i=0;i<t1;i++) //输入参数的先验值
	{
		fscanf(fp1,"%d%lf",Num+i,X1+i);
		Num[i]=Num[i]-1;
	}
	
	//输入参数的先验权矩阵(下三角矩阵)
	for(int i=0;i<t1*(t1+1)/2;i++)
		fscanf(fp1,"%lf",PX1+i);
	
	
	FILE *fp2=fopen("./新编程序教材/近代平差/算例/参数加权平差+序贯平差/r.txt","w");
	if(fp2==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	
	fprintf(fp2,"\n   参数加权平差算例：\n");
	
	PrintEquation(fp2,A,L,n,t,"%8.3lf ","");
	
	double m=Adjust_With_PX(n,t,t1,false,A,L,P,X1,PX1,Num,X,QX,V);

	PrintM(fp2,A,n*t,t,"%8.3lf","A",true);
	
	PrintM(fp2,X,t,1,"%8.3lf","X",true);
	PrintM(fp2,V,n,1,"%8.3lf","V",true);
	
	fprintf(fp2,"\n单位权中误差：  μ=%lf\n",m);
	
	fprintf(fp2,"\n   QX:");
	PrintM2(fp2,QX,t,t," %8.4lf","",true);
	


	//-----------------------------------------------------
	//   同一套数据用序贯平差

	rewind(fp1);
	fscanf(fp1,"%d%d%d",&n,&t,&t1);
	
	for(int i=0;i<n;i++) //输入误差方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp1,"%lf",&A[i*t+j]);
		fscanf(fp1,"%lf",&L[i]);
	}
	
	PrintM(fp2,A,n*t,t,"%8.3lf","A",true);
	

	for(int i=0;i<n*n;i++)P[i]=0.0;
		
	
	for(int i=0;i<n;i++)
	{

		fscanf(fp1,"%lf",P+ij(i,i));
	}
	
	for(int i=0;i<t1;i++) //输入参数的先验值
	{
		fscanf(fp1,"%d%lf",Num+i,X1+i);
		Num[i]=Num[i]-1;
	}
	
	//输入参数的先验权矩阵(下三角矩阵)
	for(int i=0;i<t1*(t1+1)/2;i++)
		fscanf(fp1,"%lf",PX1+i);
	
	fclose(fp1);
	
	inverse(PX1,t);
	double *VV=(double *)malloc(sizeof(double)*n);
	
	
	double mm=Successive_Adjustment(n,t,A,L,P,X1,PX1,VV);

	PrintM(fp2,X1,t,1,"%8.3lf ","X",true);
	PrintM(fp2,VV,n,1,"%8.3lf","V",true);
	
	PrintM2(fp2,PX1,t,t,"%8.4lf ","QX",true);
	
	fprintf(fp2,"\n单位权中误差：  μ=%lf\n",m);
	
	double max=0.0;
	for(int i=0;i<t;i++)
	{
		if(fabs(X1[i]-X[i])>max) max=fabs(X[i]-X[i]);
	}

	fprintf(fp2,"\nmax(X)=%lf",max);
	
	max=0.0;
	for(int i=0;i<n;i++)
	{
		if(fabs(VV[i]-V[i])>max) max=fabs(V[i]-VV[i]);
	}
	fprintf(fp2,"\nmax(V)=%lf",max);
	fprintf(fp2,"\nmax(m)=%lf",m-mm);
	
	
	fclose(fp2);
	free(A);
	free(L);
	free(P);
	free(X);
	free(QX);
	free(V);
	free(X1);
	free(PX1);
	free(Num);
	free(VV);
}


//////////////////////////////////////////////////////////////////////////
//   半参数估计示例
void SemiParameter_Example()
{
	const int N=5;  //观测值个数
	const int t=2;  //系统性参数个数
	double A[]={1.000, 0.000,
				1.000, 1.445,
				1.000, 2.890,
				1.000, 4.335,
				1.000, 5.780 };
	double L[5]={0.6108,1.0863,2.9034,4.5925,6.2714 };
	double P[] ={100.0,
				   0.0, 100.0,
				   0.0,   0.0, 100.0,
				   0.0,   0.0,   0.0, 100.0,
				   0.0,   0.0,   0.0,   0.0, 100.0 }; //观测权矩阵
	//正则矩阵
	double R[]={21.76763,
		       -13.16981, 29.68216,
			     6.46356,-16.93512, 31.20662,
				-2.93150,  7.91691,-16.93512, 29.68216,
				 1.07855, -2.93150,  6.46356,-13.16981, 21.76763};

	FILE *fp=fopen("./算例/半参数/Result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	
	double V[5],X[7],QX[28];//double V[N],X[t+N],QX[(t+N)*(t+N+1)/2];
		
	SemiParameter(N,t,0.5,A,P,L,R,X,QX,V);

	PrintM(fp,X,t,1," %8.4lf","参数估值",true);
	PrintM2(fp,QX,t,t," %8.4lf","参数估值的权逆阵QX",true);
	PrintM(fp,X+t,N,1," %8.4lf","非参数分量的估值",true);
	PrintM(fp,V,N,1," %8.4lf","V",true);
	
	fprintf(fp,"\n");
	fclose(fp);

}

//////////////////////////////////////////////////////////////////////////
//   岭估计算例
void Ridge_Example()
{
	const int N=5;  //观测值个数
	const int t=2;  //参数个数
	double A[]={1.00, 2.00,
				1.00, 2.11,
				1.00, 1.99,
				1.00, 1.95,
				1.00, 2.13 };
	double L[5]={5.25,5.01,4.85,4.80,5.12};
		
	double P[] ={1.0,
				 0.0, 1.0,
				 0.0, 0.0, 1.0,
				 0.0, 0.0, 0.0, 1.0,
				 0.0, 0.0, 0.0, 0.0, 1.0 }; //观测权矩阵
	
	FILE *fp=fopen("./算例/岭估计/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	
	double V[5],X[2],QX[3];//double V[N],X[t],QX[t*(t+1)/2];
		
	fprintf(fp," 最小二乘平差：");
	double m=Ridge(N,t,A,L,P,0.0,X,QX,V);
	PrintM(fp,X,t,1," %8.4lf","参数估值",true);
	PrintM2(fp,QX,t,t," %8.4lf","参数估值的权逆阵QX",true);
	PrintM(fp,V,N,1," %8.4lf","V",true);
	fprintf(fp," m=%lf\n",m);

	fprintf(fp,"\n 岭估计(k=%.3lf):",0.1);
	m=Ridge(N,t,A,L,P,0.1,X,QX,V);
	PrintM(fp,X,t,1," %8.4lf","参数估值",true);
	PrintM2(fp,QX,t,t," %8.4lf","参数估值的权逆阵QX",true);
	PrintM(fp,V,N,1," %8.4lf","V",1);
	fprintf(fp," m=%lf\n",m);
	
	fclose(fp);
}




//////////////////////////////////////////////////////////////////////////
//   用相关参数平差验证部分参数加权平差
void Example12()
{
	printf("\n用相关参数平差验证部分参数加权平差\n");
	
	FILE *fp=fopen("./算例/参数加权平差/data2.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开!\n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);
	
	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n);
	double *P=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double *X=(double *)malloc(sizeof(double)*t);
	double *Qx=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	
	for(int i=0;i<n;i++) // 输入误差方程系数
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}
	
	for(int i=0;i<n*(n+1)/2;i++)  // 输入观测权矩阵
		fscanf(fp,"%lf",P+i);
	fclose(fp);
	
	fp=fopen("./算例/参数加权平差/result2.txt","w");
	
	fprintf(fp,"=== 参数平差(观测值相关)计算 ===\n");
	
	fprintf(fp,"\n误差方程式:\n");
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<t;j++)
			fprintf(fp,"%7.3lf ",A[i*t+j]);
		fprintf(fp,"%7.3lf \n",L[i]);
	}
	
	PrintM2(fp,P,n,n,"%6.2lf ","权矩阵",false);
	
	double m=Co_Adjust(n,t,A,L,P,X,Qx,V);
	
	fprintf(fp,"\n参数平差值及其中误差：\n");
	for(int i=0; i<t; i++)
	{
		fprintf(fp,"%4d %10.3lf %10.3lf\n",i+1,X[i],sqrt(Qx[ij(i,i)])*m);
	}
	
	PrintM(fp,V,n,1,"%6.3lf ","最小二乘残差(V)",true);
	PrintM2(fp,Qx,t,t,"%10.4lf ","参数平差值的权逆阵",false);
	
	fprintf(fp,"单位权中误差：μ=%.3lf",m);
	fclose(fp);	
	free(A);
	free(L);
	free(P);
	free(X);
	free(Qx);
	free(V);
	
}


//////////////////////////////////////////////////////////////////////////
//    用参数加权函数验证序贯平差例题
void Example22()
{
	FILE *fp=fopen("./算例/序贯平差/data.txt","r");
	if(fp==NULL)
	{
		fprintf(stderr,"数据文件打不开！\n");
		return;
	}
	
	int n,t;
	fscanf(fp,"%d%d",&n,&t);
	
	double *A=(double *)malloc(sizeof(double)*n*t);
	double *L=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double *P=(double *)malloc(sizeof(double)*n*n);
	double *X=(double *)malloc(sizeof(double)*t);
	double *QX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	double *V=(double *)malloc(sizeof(double)*n);
	double *X1=(double *)malloc(sizeof(double)*t);
	double *PX=(double *)malloc(sizeof(double)*t*(t+1)/2);
	int *Num=(int *)malloc(sizeof(int)*t);
	
	for(int i=0;i<n;i++) // 输入误差方程
	{
		for(int j=0;j<t;j++)
			fscanf(fp,"%lf",A+i*t+j);
		fscanf(fp,"%lf",L+i);
	}
	
	for(int i=0;i<n*(n+1)/2;i++) // 输入观测权矩阵
	{
		fscanf(fp,"%lf",P+i);
	}
	
	for(int i=0;i<t;i++) //输入参数的先验值
	{
		fscanf(fp,"%lf",&X1[i]);
		Num[i]=i;
	}
	for(int i=0;i<t*(t+1)/2;i++) //输入参数的先验权阵
	{
		fscanf(fp,"%lf",&PX[i]);
	}	
	fclose(fp);
	
	fp=fopen("./算例/序贯平差/result(参数加权法).txt","w");
	fprintf(fp,"用参数加权平差验证序贯平差例题\n");
	
	PrintM2(fp,P,n,n," %5.2lf","P",false);
	inverse(PX,t);
	
	double m=Adjust_With_PX(n,t,t,true,A,L,P,X1,PX,Num,X,QX,V);
	
	PrintM(fp,X,t,1,"%8.3lf ","X",true); //输出参数平差值
	PrintM(fp,V,n,5,"%8.3lf  ","V",false);  //输出残差
	PrintM2(fp,QX,t,t," %8.4lf","QX",true); //输出参数平差值之权逆阵
	
	fprintf(fp,"\n单位权中误差:   μ=%.3lf\n",m);
	fclose(fp);
	free(A);
	free(L);
	free(P);
	free(X);
	free(QX);
	free(V);
	free(X1);
	free(PX);
	free(Num);
	return ;
}



//////////////////////////////////////////////////////////////////////////
//    最小二乘配置算例

void collocation_example()//此处的A，A1，L，P，QS1，QS2，QS21 应该动态申请，有空再改
{
	const int N=5;  //观测值个数
	const int t=2;  //非随机参数个数
	const int t2=4; //未测点信号个数
	
	
	double A[]={1.000, 0.000,
				1.000, 1.445,
				1.000, 2.890,
				1.000, 4.335,
				1.000, 5.780 };
	double A1[]={1.0000,0.7225,
		         1.0000,2.1675,
				 1.0000,3.6125,
				 1.0000,5.0575 };
	double L[]={ 0.6108,1.0863,2.9034,4.5925,6.2714 };
	
	double P[] ={100.0,
		           0.0, 100.0,
				   0.0,   0.0, 100.0,
				   0.0,   0.0,   0.0, 100.0,
				   0.0,   0.0,   0.0,   0.0, 100.0 }; //观测权矩阵

	//已测点信号的权逆阵
	double QS1[]={  0.12600,
		            0.05942,  0.12600,
					0.00623,  0.05942,  0.12600,
					0.00015,  0.00623,  0.05942,  0.12600,
					0.00000,  0.00015,  0.00623,  0.05942,  0.12600}; 

	//未测点信号的权逆阵
	double QS2[]={  0.12600,
		            0.05942,  0.12600,
					0.00623,  0.05942,  0.12600,
					0.00015,  0.00623,  0.05942,  0.12600 };

	//未测点信号与已测点信号的相关权逆阵
	double QS21[]={ 0.10441,  0.10441,  0.02322,  0.00115,  0.00001,
		            0.02322,  0.10441,  0.10441,  0.02322,  0.00115,
					0.00115,  0.02322,  0.10441,  0.10441,  0.02322,
					0.00001,  0.00115,  0.02322,  0.10441,  0.10441 };
		
	struct collocation Clct1;
	struct collocation *Clct=(&Clct1);
	init_collocation(&Clct1);
	
	
	Clct->CoCompute(A,L,P,QS1,N,t,Clct);
	FILE *fp=fopen("./算例/最小二乘配置/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！");
		return;
	}
	
	PrintM(fp,Clct->X,t,1," %8.4lf","非随机参数估值",true);
	PrintM2(fp,Clct->QX,t,t," %8.4lf","非随机参数估值的权逆阵",true);

	double S[N];
	Clct->CoGet_S1(S,Clct);
	PrintM(fp,S,N,1," %8.4lf","已测点信号估值",true);
		
	double S2[t2];
	Clct->CoGet_S2(S2,QS21,t2,Clct);
	PrintM(fp,S2,t2,1," %8.4lf","未测点信号估值",true);
	
	Clct->CoGet_T(S2,QS21,A1,t2,Clct);
	PrintM(fp,S2,t2,1," %8.4lf","未测点的完全信号",true);
	
	double QQ[t2*t2];
	Clct->CoGet_QS2(QS2,QS21,QQ,t2,Clct);
	PrintM2(fp,QQ,t2,t2," %8.4lf","未测点信号估值的权逆阵",true);
	
	Clct->CoGet_QT(QS2,QS21,A1,QQ,t2,Clct);
	PrintM2(fp,QQ,t2,t2," %8.4lf","未测点完全信号的权逆阵",true);
	
	double V[N];
	Clct->CoGet_V(V,Clct);
	PrintM(fp,V,N,1," %8.4lf","观测值残差(V)",true);
	
	fprintf(fp,"\n");
	fclose(fp);
	
	de_collocation(Clct);
}

//////////////////////////////////////////////////////////////////////////
//   最小二乘配置算例，
//   数据按黄教授教材,p-110,目的是验证CCollocation，
//   这个数据和CCollocation_example存在收舍误差，
/*void collocation_example2()
{
	const int N=5;  //观测值个数
	const int t=2;  //系统性参数个数
	const int t2=4; //未测点信号个数
	
	double A[]={1.000, 0.000,
		1.000, 1.445,
		1.000, 2.890,
		1.000, 4.335,
		1.000, 5.780 };
	double A1[]={1.0000,0.7225,1.0000,2.1675,1.0000,3.6125,1.0000,5.0575};
	double L[5]={ 0.6108,1.0863,2.9034,4.5925,6.2714 };
	
	double *P=(double *)malloc(N*(N+1)/2); //观测权矩阵
	
	for(int i=0;i<N;i++)
	{
		for(int j=0;j<=i;j++)
		{
			P[ij(i,j)]=(i==j)? 100.0 : 0.0;
		}
	}
	
	//已测点信号的权逆阵
	double QS1[25];
	//未测点信号的权逆阵
	double QS2[16];

	//未测点信号与已测点信号的相关权逆阵
	double QS21[20];
	
  //按黄教授书上的公式计算的权逆阵，因为收舍误差的影响
	for(int i=0;i<N;i++)
	{
		for(int j=0;j<=i;j++)
		{
			double d=A[i*t+1]-A[j*t+1];
			d=d*d*0.36;
			QS1[ij(i,j)]=0.1260*exp(-d);
		}
	}
	
	for(int i=0;i<t2;i++)
	{
		for(int j=0;j<=i;j++)
		{
			double d=A1[i*t+1]-A1[j*t+1];
			d=d*d*0.36;
			QS2[ij(i,j)]=0.1260*exp(-d);
		}
	}
	for(int i=0;i<t2;i++)
	{
		for(int j=0;j<N;j++)
		{
			double d=A1[i*t+1]-A[j*t+1];
			d=d*d*0.36;
			QS21[i*N+j]=0.1260*exp(-d);
		}
	}
	
	struct collocation Clct;
	init_collocation(&Clct);
	Clct.n=N;
	Clct.t=t;
	struct collocation *Clct1=&Clct;
	Clct.CoCompute(A,L,P,QS1,N,t,Clct1);/////////////////////////////////////////////////////////////////////////////////////////////
	printf("i am here");
	FILE *fp=fopen("./算例/最小二乘配置/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！");
		return;
	}

	fprintf(fp,"\n最小二乘配置(黄教授-p110)\n");
	

	PrintM(fp,Clct.X,t,1," %8.4lf","\n非随机参数估值",true);
	
	PrintM2(fp,Clct.QX,t,t," %8.4lf","\nX估值的权逆阵QX",true);
		
	fprintf(fp,"\n未测点信号估值:S':\n");
	
	double *S2=(double *)malloc(sizeof(double)*t2);
	
	Clct.CoGet_S2(S2,QS21,t2,&Clct);
	for(int i=0;i<t2;i++)
	{
		fprintf(fp,"%8.4lf",S2[i]);
	}

	fprintf(fp,"\n\n未测点的完全信号T:\n");
	
	Clct.CoGet_T(S2,QS21,A1,t2,&Clct);
	for(int i=0;i<t2;i++)
	{
		fprintf(fp,"%8.4lf",S2[i]);
	}

	double *QQ=(double *)malloc(sizeof(double)*t2*t2);
	fprintf(fp,"\n\n未测点信号估值的权逆阵:\n");
	Clct.CoGet_QS2(QS2,QS21,QQ,t2,&Clct);
	for(int i=0;i<t2;i++)
	{
		for(int j=0;j<=i;j++)
			fprintf(fp,"%8.4lf",QQ[ij(i,j)]);
		fprintf(fp,"\n");
	}
	
	fprintf(fp,"\n未测点完全信号的权逆阵:\n");
	Clct.CoGet_QT(QS2,QS21,A1,QQ,t2,&Clct);
	for(int i=0;i<t2;i++)
	{
		for(int j=0;j<=i;j++)
			fprintf(fp,"%8.4lf",QQ[ij(i,j)]);
		fprintf(fp,"\n");
	}
	
	fprintf(fp,"\n");
	fclose(fp);
	free(P);
	free(S2);
	
}
*/
//此函数有很大的问题


///////////////////////////////////////////////////////////////////////////


void Example12();

///////////////////////////////////////////////////////////////////////////

int main(int argc, char* argv[])
{
	printf("\n  ==== 近代平差计算 ====");
	printf("\n  1.参数加权平差");
	printf("\n  2.序贯平差例题");
	printf("\n  3.卡尔曼滤波");
	printf("\n  4.最小二乘配置  ");
	printf("\n  5.抗差估计例题（独立）");
	printf("\n  6.抗差估计例题（相关）");
	printf("\n  7.粗差探测例题");
	printf("\n  8.半参数估计");
	printf("\n  9.岭估计");
	
	printf("\n");
	
	int sw;
	scanf("%d",&sw);
	
	switch(sw) {
	case 1: //    参数加权平差
		{
			Adjust_With_PX_Example();
						
		}
		break;
		
	case 2: //    序贯平差例题
		{
			printf("\n\n进行序贯平差\n");
			SuccessivExample();

		}
		break;
		
	case 3: //   Kalnman滤波算例
		{
			KalmanFilter_Example3();
			
		}
		break;
	case 4: //最小二乘配置
		{
			collocation_example();
			//collocation_example2();
			
		}
		break;
	case 5: // 抗差估计例题（独立）
		{
			printf("\n\n进行抗差估计（观测值独立）\n");
			
			Robust_Example();   
		}
		break;
	case 6: //  抗差估计例题（相关）
		{
			CoRobust_Example();
		}
		break;
		
	case 7: //  粗差探测例题
		{
			DataSnooping_Example();   
			
		}
		break;
		
	case 8: //   半参数估计算例
		{
			SemiParameter_Example();			
		}
		break;
	case 9: //   岭估计
		{
			Ridge_Example();			
		}
		break;
		
	default :  
		break;
		
	}
	
	return 0;
}

