// MyGPS.h: interface for the CMyGPS class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _MYGPS_H
#define _MYGPS_H

#include <stdlib.h>

#include <stdbool.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
/*
class CCoGPS  
{
public:
    CCoGPS();
	virtual ~CCoGPS();
	FILE   *resultfp; //输出文件指针
	bool  m_IsPx;  // 是否参数加权平差	
	
	int    Anumber;      //同步区数，向量组总数
    int    Pnumber;      //总点数
    int    Vnumber;      //向量总数
    int    unPnumber;    //未知点数

    double *XYZ;     // 坐标数组	
    char   **Pname;  // 点名指针数组
	bool   *IsKnown;//已知点标志数组
	
    int    *dir0;        //各同步区首向量在观测值中的序号
    int    *dir1,*dir2;  //向量端点号

	double *L;  //全区观测向量
	double *ATPA,*ATPL;
	double MEDIAN;  //由中位数计算的单位权中误差
	double Sigma;   //由VTPV计算的单位权中误差
	double **P;     //权矩阵数组；
	double *QV;     //观测值残差权倒数
	double *V;      //残差
    double *PV;     //
	double *W;      //权因子	

    double *MxMyMz;  //已知点的中误差向量
	double *KnownXYZ;  //已知点坐标,参数加权平差时用
	int    *KnownPoints; //与已知点坐标相应的点号
    double *KnownPx;  //已知点权矩阵
	int    *AreaNumber;  //各向量所属向量组的编号	

public:
	bool  InputData(char *DataFile); //输入原始数据
	bool  InputKnownXYZ(char *file,bool corelated); //输入已知点坐标
    void  PrintData(); //打印原始数据
		
	void  PrintXYZ();  //打印平差坐标
    void  PrintLV(char *Title,double *LV);//打印观测值、残差

	void  LeastSquares(); //最小二乘平差计算
	void  Free();         //秩亏自由网平差计算
	void  Quasi_Stable(char *file);//拟稳平差计算
	void  Robust(int fname,double eps); // 抗差最小二乘平差	
	void  DataSnooping(double Arfa,int MaxLoop);  // 粗差探测计算

	void CCoGPS::Helmert();
		
private:
	void  CaATPA();	// 组成法方程
    void  CaATPAi(int n,int *dir1,int *dir2,double *Pi,double *L);  
	void  Known();//已知点处理函数
	void   CaLV(double V[]);//计算残差或自由项向量
	double CaVTPV(); //计算残差二次型
    double Ca_dX(bool IsPrint); //法方程解算,返回最大坐标改正数
	int  GetStationNumber(char *buf); //保存点名，返回点号
	double Ca_VTPV_XYZ();//已知点加相关权平差时坐标改正数二次型
	
	// 以下是粗差探测计算辅助函数
	void CaJTPJ(double JTPJ[], int Jint[],int s);
	double CaQg(int s,int Jint[],double gross[],
		         double Qg[],double JTPA[],double JTPV[] );
	void CaJTPA(double JTPA[],int s,int n0);
	void Ca_X_Qx(double gross[],double Qg[],double JTPA[],int s);

	//以下是抗差估计辅助函数
    void   Ca_UintV(); 
	void   caQV();
};
*/

struct CCoGPS  
{
//public:
    	void (*CCoGPS)(struct CCoGPS *ccgps);
	void (*de_CCoGPS)(struct CCoGPS *ccgps);
	FILE   *resultfp; //输出文件指针
	bool  m_IsPx;  // 是否参数加权平差	
	
	int    Anumber;      //同步区数，向量组总数
    	int    Pnumber;      //总点数
    	int    Vnumber;      //向量总数
    	int    unPnumber;    //未知点数

    	double *XYZ;     // 坐标数组	
    	char   **Pname;  // 点名指针数组
	bool   *IsKnown;//已知点标志数组
	
    	int    *dir0;        //各同步区首向量在观测值中的序号
    	int    *dir1,*dir2;  //向量端点号

	double *L;  //全区观测向量
	double *ATPA,*ATPL;
	double MEDIAN;  //由中位数计算的单位权中误差
	double Sigma;   //由VTPV计算的单位权中误差
	double **P;     //权矩阵数组；
	double *QV;     //观测值残差权倒数
	double *V;      //残差
    	double *PV;     //
	double *W;      //权因子	

    	double *MxMyMz;  //已知点的中误差向量
	double *KnownXYZ;  //已知点坐标,参数加权平差时用
	int    *KnownPoints; //与已知点坐标相应的点号
    	double *KnownPx;  //已知点权矩阵
	int    *AreaNumber;  //各向量所属向量组的编号	

//public:
	bool  (*InputData)(char *DataFile,struct CCoGPS *ccgps); //输入原始数据
	bool  (*InputKnownXYZ)(char *file,bool corelated,struct CCoGPS *ccgps); //输入已知点坐标
    	void  (*PrintData)(struct CCoGPS *ccgps); //打印原始数据
		
	void  (*PrintXYZ)(struct CCoGPS *ccgps);  //打印平差坐标
    	void  (*PrintLV)(char *Title,double *LV,struct CCoGPS *ccgps);//打印观测值、残差

	void  (*LeastSquares)(struct CCoGPS *ccgps); //最小二乘平差计算
	void  (*Free)(struct CCoGPS *ccgps);         //秩亏自由网平差计算
	void  (*Quasi_Stable)(char *file,struct CCoGPS *ccgps);//拟稳平差计算
	void  (*Robust)(int fname,double eps,struct CCoGPS *ccgps); // 抗差最小二乘平差	
	void  (*DataSnooping)(double Arfa,int MaxLoop,struct CCoGPS *ccgps);  // 粗差探测计算

	void (*Helmert)(struct CCoGPS *ccgps);
		
//private:
	void  (*CaATPA)(struct CCoGPS *ccgps);	// 组成法方程
    	void  (*CaATPAi)(int n,int *dir1,int *dir2,double *Pi,double *L,struct CCoGPS *ccgps);  
	void  (*Known)(struct CCoGPS *ccgps);//已知点处理函数
	void   (*CaLV)(double V[],struct CCoGPS *ccgps);//计算残差或自由项向量
	double (*CaVTPV)(struct CCoGPS *ccgps); //计算残差二次型
    	double (*Ca_dX)(bool IsPrint,struct CCoGPS *ccgps); //法方程解算,返回最大坐标改正数
	int  (*GetStationNumber)(char *buf,struct CCoGPS *ccgps); //保存点名，返回点号
	double (*Ca_VTPV_XYZ)(struct CCoGPS *ccgps);//已知点加相关权平差时坐标改正数二次型
	
	// 以下是粗差探测计算辅助函数
	void (*CaJTPJ)(double JTPJ[], int Jint[],int s,struct CCoGPS *ccgps);
	double (*CaQg)(int s,int Jint[],double gross[],
		         double Qg[],double JTPA[],double JTPV[] ,struct CCoGPS *ccgps);
	void (*CaJTPA)(double JTPA[],int s,int n0,struct CCoGPS *ccgps);
	void (*Ca_X_Qx)(double gross[],double Qg[],double JTPA[],int s,struct CCoGPS *ccgps);

	//以下是抗差估计辅助函数
    	void   (*Ca_UintV)(struct CCoGPS *ccgps); 
	void   (*caQV)(struct CCoGPS *ccgps);
};

//构造函数
void CCoGPS_CCoGPS(struct CCoGPS *ccgps);
//析构函数
void CCoGPS_de_CCoGPS(struct CCoGPS *ccgps);

bool  CCoGPS_InputData(char *DataFile,struct CCoGPS *ccgps); //输入原始数据
bool  CCoGPS_InputKnownXYZ(char *file,bool corelated,struct CCoGPS *ccgps); //输入已知点坐标
void  CCoGPS_PrintData(struct CCoGPS *ccgps); //打印原始数据
		
void  CCoGPS_PrintXYZ(struct CCoGPS *ccgps);  //打印平差坐标
void  CCoGPS_PrintLV(char *Title,double *LV,struct CCoGPS *ccgps);//打印观测值、残差

void  CCoGPS_LeastSquares(struct CCoGPS *ccgps); //最小二乘平差计算
void  CCoGPS_Free(struct CCoGPS *ccgps);         //秩亏自由网平差计算
void  CCoGPS_Quasi_Stable(char *file,struct CCoGPS *ccgps);//拟稳平差计算
void  CCoGPS_Robust(int fname,double eps,struct CCoGPS *ccgps); // 抗差最小二乘平差	
void  CCoGPS_DataSnooping(double Arfa,int MaxLoop,struct CCoGPS *ccgps);  // 粗差探测计算

void  CCoGPS_Helmert(struct CCoGPS *ccgps);
		

void  CCoGPS_CaATPA(struct CCoGPS *ccgps);	// 组成法方程
void  CCoGPS_CaATPAi(int n,int *dir1,int *dir2,double *Pi,double *L,struct CCoGPS *ccgps);  
void  CCoGPS_Known(struct CCoGPS *ccgps);//已知点处理函数
void  CCoGPS_CaLV(double V[],struct CCoGPS *ccgps);//计算残差或自由项向量
double CCoGPS_CaVTPV(struct CCoGPS *ccgps); //计算残差二次型
double CCoGPS_Ca_dX(bool IsPrint,struct CCoGPS *ccgps); //法方程解算,返回最大坐标改正数
int  CCoGPS_GetStationNumber(char *buf,struct CCoGPS *ccgps); //保存点名，返回点号
double CCoGPS_Ca_VTPV_XYZ(struct CCoGPS *ccgps);//已知点加相关权平差时坐标改正数二次型
	
	// 以下是粗差探测计算辅助函数
void CCoGPS_CaJTPJ(double JTPJ[], int Jint[],int s,struct CCoGPS *ccgps);
double CCoGPS_CaQg(int s,int Jint[],double gross[],
		         double Qg[],double JTPA[],double JTPV[] ,struct CCoGPS *ccgps);
void CCoGPS_CaJTPA(double JTPA[],int s,int n0,struct CCoGPS *ccgps);
void CCoGPS_Ca_X_Qx(double gross[],double Qg[],double JTPA[],int s,struct CCoGPS *ccgps);

	//以下是抗差估计辅助函数
void  CCoGPS_Ca_UintV(struct CCoGPS *ccgps); 
void  CCoGPS_caQV(struct CCoGPS *ccgps);


/*
#define CCoGPS(abc) 	FILE   *resultfp=; \
			bool  m_IsPx; \
					\
			int    Anumber;  \
    			int    Pnumber; \
    			int    Vnumber; \
    			int    unPnumber; \
					\
    			double *XYZ; 	\
    			char   **Pname;\
			bool   *IsKnown;\
					\
    			int    *dir0; \
    			int    *dir1,*dir2;  \
					\
			double *L;  \
			double *ATPA,*ATPL;\
			double MEDIAN; \
			double Sigma;  \
			double **P;   \
			double *QV;  \
			double *V;   \
    			double *PV;   \
			double *W;    \
					\
    			double *MxMyMz;  \
			double *KnownXYZ;  \
			int    *KnownPoints;\
    			double *KnownPx;  \
			int    *AreaNumber
*/
#endif // _MYGPS_H





















