// 
//
//////////////////////////////////////////////////////////////////////


#ifndef _PLANENTADJUST_H
#define _PLANENTADJUST_H

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>


/*
class CPlaneNetAdjust  
{
public:
	FILE   *resultfp;   //结果文件指针
	int    m_Pnumber;   //总点数
	int    m_Lnumber;   //方向组总数
	int    m_Nnumber;   //方向值总数
	int    m_knPnumber; //已知点总数
	int    m_StableNumber; //拟稳点数
	
	int    m_Tnumber;   //方位角观测值个数
	int    m_Snumber;   //边长观测值个数
	
	int    *dir1;   //测站点号
	int    *dir2;   //观测方向的点号
	int    *dir0;   //测站零方向在方向值数组中的位置

	char   **Pname;     //点名地址数组
	
	double *L,*V; //方向观测值及其残差数组
	double *XY;   //坐标数组
	double *ATPA,*ATPL; //法方程系数阵、法方程自由项
	double *dX;   //未知参数数组（坐标改正数、定向角改正数）
	double m_pvv; // [pvv]
	double m_mu;  //验后单位权中误差
	
	bool *IsStable;  //拟稳点标志数组

	double ma,mT; //方向值中误差、方位角中误差
	double mS1,mS2; //边长固定误差、比例误差
	
	int     *T_dir1; //方位角测站点点号数组
	int     *T_dir2; //方位角照准点点号数组
	double  *T_L;    //方位角观测值数组
	double  *T_V;    //方位角残差数组
	
	int     *S_dir1; //边长观测值测站点号数组
	int     *S_dir2; //边长观测值照准点号数组
	double  *S_L;    //边长观测值数组
	double  *S_V;    //边长残差数组	

	bool    *Usable;  //观测值可用标志数组
	
	CPlaneNetAdjust();
	virtual ~CPlaneNetAdjust();	
	
	void   InputData(char *DATAFILE);//输入原始数据
	void   PrintData();              //输出原始数据
	int    GetStationNumber(char *name); //保存点名，返回点号
	
	double Get_S12(int k1,int k2);  //查找边长观测值
	double Get_T12(int k1,int k2);  //查找方位角观测值
	double Get_Angle(int p,int p1,int p2);//查找角度值
	void   ca_xy0(); //近似坐标计算(三角网)
	void   ca_x0y0();//近似坐标计算（导线网）
		
	double ca_T12(int k1,int k2);  //用坐标计算方位角，返回值为弧度值,
	double ca_ab(int k1,int k2,double B[],int Bin[]); // ab系数计算
	double ca_cd(int k1,int k2,double B[],int Bin[]); // cd系数计算
	void   ca_ATPA(); //法方程组成
	void   ca_ATPAi(double B[],int Bint[],double p,
									double Li,int m);//法方程累加项计算
	double ca_dX();  //参数平差值计算
	double ca_V();   //残差计算
	double qq(double B[],int Bin[]); //权倒数计算
	void   PrintResult(); //输出平差成果

	void LS_Adjust(char *data_file); //最小二乘平差
	void Free(); //自由网平差
	int  Quasi_Stable(char *QuasiStablefile); //拟稳平差
	double *ca_GT(char *file);//自由网平差用的G矩阵

	void ErrorEllipse(); //误差椭圆计算

	double  Snooping(double arfa);
		

};*/
//所有的指针都使用mallco分配，切勿使用其他方法，因为都要free
struct CPlaneNetAdjust  
{
	FILE   *resultfp;   //结果文件指针
	int    m_Pnumber;   //总点数
	int    m_Lnumber;   //方向组总数
	int    m_Nnumber;   //方向值总数
	int    m_knPnumber; //已知点总数
	int    m_StableNumber; //拟稳点数
	
	int    m_Tnumber;   //方位角观测值个数
	int    m_Snumber;   //边长观测值个数
	
	int    *dir1;   //测站点号
	int    *dir2;   //观测方向的点号
	int    *dir0;   //测站零方向在方向值数组中的位置

	char   **Pname;     //点名地址数组
	
	double *L,*V; //方向观测值及其残差数组
	double *XY;   //坐标数组
	double *ATPA,*ATPL; //法方程系数阵、法方程自由项
	double *dX;   //未知参数数组（坐标改正数、定向角改正数）
	double m_pvv; // [pvv]
	double m_mu;  //验后单位权中误差
	
	bool *IsStable;  //拟稳点标志数组

	double ma,mT; //方向值中误差、方位角中误差
	double mS1,mS2; //边长固定误差、比例误差
	
	int     *T_dir1; //方位角测站点点号数组
	int     *T_dir2; //方位角照准点点号数组
	double  *T_L;    //方位角观测值数组
	double  *T_V;    //方位角残差数组
	
	int     *S_dir1; //边长观测值测站点号数组
	int     *S_dir2; //边长观测值照准点号数组
	double  *S_L;    //边长观测值数组
	double  *S_V;    //边长残差数组	

	bool    *Usable;  //观测值可用标志数组
	
	void (*CPlaneNetAdjust)(struct CPlaneNetAdjust *clna);
	void (*de_CPlaneNetAdjust)(struct CPlaneNetAdjust *clna);	
	
	void   (*InputData)(char *DATAFILE,struct CPlaneNetAdjust *clna);//输入原始数据
	void   (*PrintData)(struct CPlaneNetAdjust *clna);              //输出原始数据
	int    (*GetStationNumber)(char *name,struct CPlaneNetAdjust *clna); //保存点名，返回点号
	
	double (*Get_S12)(int k1,int k2,struct CPlaneNetAdjust *clna);  //查找边长观测值
	double (*Get_T12)(int k1,int k2,struct CPlaneNetAdjust *clna);  //查找方位角观测值
	double (*Get_Angle)(int p,int p1,int p2,struct CPlaneNetAdjust *clna);//查找角度值
	void   (*ca_xy0)(struct CPlaneNetAdjust *clna); //近似坐标计算(三角网)
	void   (*ca_x0y0)(struct CPlaneNetAdjust *clna);//近似坐标计算（导线网）
		
	double (*ca_T12)(int k1,int k2,struct CPlaneNetAdjust *clna);  //用坐标计算方位角，返回值为弧度值,
	double (*ca_ab)(int k1,int k2,double B[],int Bin[],struct CPlaneNetAdjust *clna); // ab系数计算
	double (*ca_cd)(int k1,int k2,double B[],int Bin[],struct CPlaneNetAdjust *clna); // cd系数计算
	void   (*ca_ATPA)(struct CPlaneNetAdjust *clna); //法方程组成
	void   (*ca_ATPAi)(double B[],int Bint[],double p,
			double Li,int m,struct CPlaneNetAdjust *clna);//法方程累加项计算
	double (*ca_dX)(struct CPlaneNetAdjust *clna);  //参数平差值计算
	double (*ca_V)(struct CPlaneNetAdjust *clna);   //残差计算
	double (*qq)(double B[],int Bin[],struct CPlaneNetAdjust *clna); //权倒数计算
	void   (*PrintResult)(struct CPlaneNetAdjust *clna); //输出平差成果

	void (*LS_Adjust)(char *data_file,struct CPlaneNetAdjust *clna); //最小二乘平差
	void (*Free)(struct CPlaneNetAdjust *clna); //自由网平差
	int  (*Quasi_Stable)(char *QuasiStablefile,struct CPlaneNetAdjust *clna); //拟稳平差
	double *(*ca_GT)(char *file,struct CPlaneNetAdjust *clna);//自由网平差用的G矩阵

	void (*ErrorEllipse)(struct CPlaneNetAdjust *clna); //误差椭圆计算

	double  (*Snooping)(double arfa,struct CPlaneNetAdjust *clna);
};

//构造函数
void CPlaneNetAdjust_CPlaneNetAdjust(struct CPlaneNetAdjust *clna);
//析构函数
void CPlaneNetAdjust_de_CPlaneNetAdjust(struct CPlaneNetAdjust *clna);


//	   点号存贮、根据点名换算点号
int  CPlaneNetAdjust_GetStationNumber(char *name,struct CPlaneNetAdjust *clna);

//   读取原始数据文件
void CPlaneNetAdjust_InputData(char *file,struct CPlaneNetAdjust *clna);

//  原始数据输出
void CPlaneNetAdjust_PrintData(struct CPlaneNetAdjust *clna);

//   根据三点号返回以p为顶点的一个夹角
double CPlaneNetAdjust_Get_Angle(int p,int p1,int p2,struct CPlaneNetAdjust *clna);

//        计算近似坐标(三角网)
void CPlaneNetAdjust_ca_xy0(struct CPlaneNetAdjust *clna);

//        计算方向误差方程式ab系数
double CPlaneNetAdjust_ca_ab(int k1,int k2,double A[],int Ain[],struct CPlaneNetAdjust *clna);

//       计算边长误差方程系数
double CPlaneNetAdjust_ca_cd(int k1,int k2,double A[],int Ain[],struct CPlaneNetAdjust *clna);

//	一个误差方程式组成的法方程
void CPlaneNetAdjust_ca_ATPAi(double B[],int Bin[],double p,double Li,int m,struct CPlaneNetAdjust *clna);

//         组 成 法 方 程 式
void CPlaneNetAdjust_ca_ATPA(struct CPlaneNetAdjust *clna);

//  参数平差值计算,返回值：坐标改正数的最大值
double CPlaneNetAdjust_ca_dX(struct CPlaneNetAdjust *clna);

//     计算最小二乘残差及[pvv]
double  CPlaneNetAdjust_ca_V(struct CPlaneNetAdjust *clna);

//     粗差探测计算函数
double  CPlaneNetAdjust_Snooping(double arfa,struct CPlaneNetAdjust *clna);

//   平差成果输出
void  CPlaneNetAdjust_PrintResult(struct CPlaneNetAdjust *clna);

//            平面方位角计算
double CPlaneNetAdjust_ca_T12(int k1,int k2,struct CPlaneNetAdjust *clna);  // 返回值为弧度值,

//            权 倒 数 计 算
double CPlaneNetAdjust_qq(double B[],int Bin[],struct CPlaneNetAdjust *clna);

//       边角网拟稳平差
int CPlaneNetAdjust_Quasi_Stable(char *file,struct CPlaneNetAdjust *clna);

//   计算G矩阵(转置)
double * CPlaneNetAdjust_ca_GT(char *file,struct CPlaneNetAdjust *clna);

//    自由网平差计算函数
void CPlaneNetAdjust_Free(struct CPlaneNetAdjust *clna);

//    最小二乘平差
void CPlaneNetAdjust_LS_Adjust(char *data_file,struct CPlaneNetAdjust *clna);

//    导线网近似坐标计算函数
void CPlaneNetAdjust_ca_x0y0(struct CPlaneNetAdjust *clna);

//    查找边长观测值
double CPlaneNetAdjust_Get_S12(int k1,int k2,struct CPlaneNetAdjust *clna);

//      在方位角观测值中查找
double CPlaneNetAdjust_Get_T12(int k1,int k2,struct CPlaneNetAdjust *clna);

//         计算误差椭圆
//   2007-03-20, 为程序教材编的函数.
void CPlaneNetAdjust_ErrorEllipse(struct CPlaneNetAdjust *clna );


#endif // _PLANENTADJUST_H
